package cn.com.qmth.stmms.ms.collect.util;

import java.awt.image.BufferedImage;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.HashSet;

import javax.imageio.ImageIO;

import org.apache.commons.codec.digest.DigestUtils;

import cn.com.qmth.stmms.ms.commons.config.SystemConfig;
import cn.com.qmth.stmms.ms.commons.utils.image.ImageCompression;
import cn.com.qmth.stmms.ms.core.domain.Paper;
import cn.com.qmth.stmms.ms.core.repository.PaperRepo;

public class RotateTask  implements Runnable {
	
    private Paper paper;
    private int degree;
    private PaperRepo paperRepo;
    private SystemConfig systemConfig;
    private HashSet<String> papers;

    public RotateTask(Paper paper,int degree, PaperRepo paperRepo, SystemConfig systemConfig, HashSet<String> papers) {
    	this.paper = paper;
        this.degree = degree;
        this.paperRepo = paperRepo;
        this.systemConfig = systemConfig;
        this.papers = papers;
    }

	@Override
	public void run() {
		long start = System.currentTimeMillis();
		try {
			String thumbPath = systemConfig.getThumbDir() + File.separator + paper.getWorkId() + File.separator + paper.getSubject().toString()
					+ File.separator + paper.getAreaCode() + File.separator + paper.getExamNumber() + ".jpg";
			File thumbFile = new File(thumbPath);
			File thumbOut =  new File(systemConfig.getThumbDir() + File.separator + paper.getWorkId() + File.separator + paper.getSubject().toString()
	    			+ File.separator + paper.getAreaCode() + File.separator + paper.getId() + ".jpg");
			if (thumbFile.exists()) {
				InputStream is = new FileInputStream(thumbFile);
				BufferedImage image = ImageIO.read(is);
				ImageCompression.rotate(thumbFile, thumbOut, degree);
				is.close();
				thumbFile.renameTo(new File(systemConfig.getThumbDir() + File.separator + paper.getWorkId() + File.separator + paper.getSubject().toString()
		    			+ File.separator + paper.getAreaCode() + File.separator + paper.getExamNumber() +"_" + start + ".jpg"));
				thumbOut.renameTo(new File(thumbPath));
			}
			
		    String imagePath = systemConfig.getImageDir() + File.separator + paper.getWorkId() + File.separator + paper.getSubject().toString()
		    			+ File.separator + paper.getAreaCode() + File.separator + paper.getExamNumber() + ".jpg";
			File imageFile = new File(imagePath);
			File imageOut = new File(systemConfig.getImageDir() + File.separator + paper.getWorkId() + File.separator + paper.getSubject().toString()
		    			+ File.separator + paper.getAreaCode() + File.separator + paper.getId() + ".jpg");
			if (imageFile.exists()) {
				InputStream is = new FileInputStream(imageFile);
				BufferedImage image = ImageIO.read(is);
				ImageCompression.rotate(imageFile, imageOut, degree);
				imageFile.renameTo(new File(systemConfig.getImageDir() + File.separator + paper.getWorkId() + File.separator + paper.getSubject().toString()
		    			+ File.separator + paper.getAreaCode() + File.separator + paper.getExamNumber() +"_"+ start + ".jpg"));
				imageOut.renameTo(new File(imagePath));
				is.close();
			}
	        FileInputStream in = new FileInputStream(new File(imagePath));
	        String sliceMD5 = DigestUtils.md5Hex(in);
			paper.setSliceMD5(sliceMD5);
			paperRepo.save(paper);
			papers.remove(paper.getExamNumber());
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException ioe) {
			ioe.printStackTrace();
		}
	}
}
