package cn.com.qmth.stmms.ms.core.domain;

import java.io.Serializable;
import java.util.Date;

import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;

/**
 * 
 * @Description: 操作记录
 * @author ting.yin
 * @date 2016年10月21日
 */
@Entity
public class MarkLog implements Serializable {

	private static final long serialVersionUID = -8376036816154911286L;

	@Id
	@GeneratedValue
	private Long id;

	private Long workId;

	private MarkStage markStage;

	private String loginName;
	
	private String markerName;

	private String examNumber;
	
	private String secretNumber;

	private String remark;
	
	private String result;

	@Temporal(value = TemporalType.DATE)
	private Date createdOn;

	public MarkLog() {
	}

	public MarkLog(Long workId, MarkStage markStage, String loginName, String markerName,
			String examNumber,String secretNumber,String result) {
		this.workId = workId;
		this.markStage = markStage;
		this.loginName = loginName;
		this.markerName = markerName;
		this.examNumber = examNumber;
		this.secretNumber = secretNumber;
		this.result = result;
		this.createdOn = new Date();
	}

	public Long getId() {
		return id;
	}

	public void setId(Long id) {
		this.id = id;
	}

	public Long getWorkId() {
		return workId;
	}

	public void setWorkId(Long workId) {
		this.workId = workId;
	}

	public MarkStage getMarkStage() {
		return markStage;
	}

	public void setMarkStage(MarkStage markStage) {
		this.markStage = markStage;
	}

	public String getRemark() {
		return remark;
	}

	public void setRemark(String remark) {
		this.remark = remark;
	}

	public Date getCreatedOn() {
		return createdOn;
	}

	public void setCreatedOn(Date createdOn) {
		this.createdOn = createdOn;
	}

	public String getResult() {
		return result;
	}

	public void setResult(String result) {
		this.result = result;
	}

	public String getLoginName() {
		return loginName;
	}

	public void setLoginName(String loginName) {
		this.loginName = loginName;
	}

	public String getMarkName() {
		return markerName;
	}

	public void setMarkName(String markName) {
		this.markerName = markName;
	}

	public String getExamNumber() {
		return examNumber;
	}

	public void setExamNumber(String examNumber) {
		this.examNumber = examNumber;
	}

	public String getSecretNumber() {
		return secretNumber;
	}

	public void setSecretNumber(String secretNumber) {
		this.secretNumber = secretNumber;
	}

}
